HDU-1520 树形dp

Problem Description

There is going to be a party to celebrate the 80-th Anniversary of the Ural State University. The University has a hierarchical structure of employees. It means that the supervisor relation forms a tree rooted at the rector V. E. Tretyakov. In order to make the party funny for every one, the rector does not want both an employee and his or her immediate supervisor to be present. The personnel office has evaluated conviviality of each employee, so everyone has some number (rating) attached to him or her. Your task is to make a list of guests with the maximal possible sum of guests' conviviality ratings.

Input

Employees are numbered from 1 to N. A first line of input contains a number N. 1 <= N <= 6 000. Each of the subsequent N lines contains the conviviality rating of the corresponding employee. Conviviality rating is an integer number in a range from -128 to 127. After that go T lines that describe a supervisor relation tree. Each line of the tree specification has the form:
L K
It means that the K-th employee is an immediate supervisor of the L-th employee. Input is ended with the line
0 0

Output

Output should contain the maximal sum of guests' ratings.

Sample Input

 
 

7 1 1 1 1 1 1 1 1 3 2 3 6 4 7 4 4 5 3 5 0 0

Sample Output

5
————————————————————————————————————————————————————————————
这道题不难……在比赛的时候基本的思路都想出来了,但是之前没有做过这类题,思路比较迟钝,不敢下手……结果上手知道怎么做以后63行解决……嘛……算是被dp这个名头给吓住的典例吧。
————————————————————————————————————————————————————————————
  首先说一下题意,就是说这道题有n个人,每个人都有自己的娱乐度,但是呢,有些人是其中一些人的上司,在这种场合会很尴尬,所以不能同时出现。上手的时候最容易的犯得错误就是想当然的直接用一层隔着一层来直接讨论,但是对于同样一层,可以不选,即对于1,2,3,4层,可以从1开始,略过2层,因为说不定1和4的值很高……嘛,这个自己理解吧。
  然后呢,既然不能简单的讨论,也就是说这个要做一个选和不选的选择,选的话,那么对于所有的孩子,取其不在的时候的最大值,如果不选的话,那孩子来不来要看其娱乐度总和到底是来的大还是不来的大,dp公式就是:
dp[i][0]+=max(dp[child-ith][0],dp[child-ith][1]) dp[i][1]+=dp[child-ith][0](对所有的孩子都过一遍)
上述过程从底向上来一遍就好了
————————————————————————————————————————————————————————————
 
 

#include<stdio.h>
#include<string.h>
#include<iostream>
#include<vector>
#include<algorithm>
#include<string>
#include<queue>
#include<climits>
#include<map>
#include<stack>
#include<list>
#define file_in freopen("input.txt","r",stdin)
#define MAX 8000
#define HASH 100019
using namespace std;
#define ll long long
#define FF(x,y) for(int i=x;i<y;i++)
struct node {
    int index;
    vector<int>child;
};
vector<node>sto;

int dp[MAX][2];
void dfs(int index)
{
    for (int i = 0; i < sto[index].child.size(); i++)//其实这里应该这么写
    {
        dfs(sto[index].child[i]);
        dp[index][0] += max(dp[sto[index].child[i]][0], dp[sto[index].child[i]][1]);//<-delete
        dp[index][1] += dp[sto[index].child[i]][0];//<-delete
    }//就是把孩子都处理一边
    //for (int i = 0; i < sto[index].child.size(); i++)
    //{
    //    dp[index][0] += max(dp[sto[index].child[i]][0], dp[sto[index].child[i]][1]);//然后全部相加一边,得到正解
    //    dp[index][1] += dp[sto[index].child[i]][0];
    //}
}
int main() {

    int num;
    while (scanf("%d", &num) != EOF)
    {
        sto.clear();
        sto.resize(num + 1);
        for (int i = 1; i <= num; i++)
        {
            scanf("%d", &dp[i][1]);
            dp[i][0] = 0;
        }
        int to, from;
        map<int, int>M;
        while (1)
        {
            scanf("%d %d", &to, &from);
            if (to == 0)break;
            sto[from].child.push_back(to);
            M[to] = from;
        }
        int  root;
        for (int i = 1; i <= num; i++)
        {
            if (M.find(i) == M.end())root = i;
        }
        dfs(root);
        cout << max(dp[root][0], dp[root][1]) << endl;
    }
   

}
/*
7
1
1
1
1
1
1
1
1 3
2 3
6 4
7 4
4 5
3 5
0 0
*/

转载于:https://www.cnblogs.com/stultus/p/6539652.html

  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值